
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.beans.*;
import java.util.*;

import com.javawisdom.util.print.*;

public class JTextAreaTest  extends JFrame{
	
	

	JPanel mainPanel;
	
	JTabbedPane tabPane;
	
	JvPrinter jvprinter;

	JFCTextAreaAppPanel jfcTextAreaAppPanel;


	ButtonsAppPanel buttonsAppPanel;
		public JTextAreaTest()
	{
		super();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setTitle("JvJvPrinter Test");
	
    	mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout(5, 5));

		tabPane = new JTabbedPane();
		jvprinter = new JvPrinter();
		
		jfcTextAreaAppPanel = new JFCTextAreaAppPanel(this);
		tabPane.addTab("JTextArea", jfcTextAreaAppPanel);
		buttonsAppPanel = new ButtonsAppPanel(this);

		mainPanel.add(tabPane, BorderLayout.CENTER);
		mainPanel.add(buttonsAppPanel, BorderLayout.SOUTH);
	
		getContentPane().add(mainPanel, BorderLayout.CENTER);
	}
	public static void main(String args[])
	{

		JTextAreaTest printerApp = new JTextAreaTest();
		printerApp.setBounds(5,5,600,550);
		printerApp.show();
	}
class JFCTextAreaAppPanel extends JPanel
{
	JTextAreaTest test;
 
	JTextArea textArea;

	JPanel leftPanel;



	public JFCTextAreaAppPanel(JTextAreaTest test)
	{
		this.test = test;
		setLayout(new BorderLayout(5, 5));

		textArea = new JTextArea();
		textArea.setText("This is a JTextArea Demo\n Build scripts or files, created and developed during a software development project,\n are important artifacts for development teams; their quality and speed significantly affect a team's productivity.\n As a project's size grows, the build process also grows and becomes more complex.\n Long builds waste a developer's time and amplify the time required to view the results of the changes made to the system.\n In addition, the XP (extreme programming) practice of continuous integration grows more difficult as developers'\n working sessions increase because of the long builds that do needless work every time they execute. Ultimately,\n these negative consequences of long builds impair the project's progress. In this article, Arin Ghazarian\n describes the concepts of incremental builds, dependency checking, \nand other related concepts in build processes, then proposes some techniques and guidelines to optimize and quicken \nbuilds written in Apache Ant. ");
		textArea.setFont(new Font("Dialog", Font.PLAIN, 15));
		textArea.setForeground(Color.black);


		leftPanel = new JPanel();
		//
		leftPanel.setLayout(new BorderLayout(5, 5));
		leftPanel.add(new JScrollPane(textArea), BorderLayout.CENTER);

		add(leftPanel, BorderLayout.CENTER);

	}

	public Component getComponent()
	{
		return textArea;
	}


}

}

class ButtonsAppPanel extends JPanel implements ActionListener
{
	JTextAreaTest printerApp;

	JButton pageSetupButton;
	JButton previewButton;
	JButton printButton;

	public ButtonsAppPanel(JTextAreaTest printerApp)
	{
		this.printerApp = printerApp;
		setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));

		pageSetupButton = new JButton("Page Setup");
		pageSetupButton.addActionListener(this);

		previewButton = new JButton("Preview");
		previewButton.addActionListener(this);

		printButton = new JButton("Print");
		printButton.addActionListener(this);

		add(pageSetupButton);
		add(previewButton);
		add(printButton);
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == pageSetupButton)
		{
			printerApp.jvprinter.pageSetup(printerApp);
		}
		else if(e.getSource() == previewButton)
		{
			 if(printerApp.tabPane.getSelectedIndex() == 0)
				printerApp.jvprinter.setJTextArea((JTextArea)printerApp.jfcTextAreaAppPanel.getComponent());
			printerApp.jvprinter.preview(printerApp);
		}
		else if(e.getSource() == printButton)
		{
		if(printerApp.tabPane.getSelectedIndex() == 0)
				printerApp.jvprinter.setJTextArea((JTextArea)printerApp.jfcTextAreaAppPanel.getComponent());
		printerApp.jvprinter.print();
		}
	}
}
